

#include "stdafx.h"
#include "cxom.h"
#include "MyDocuments.h"
#include "MyDocument.h"
#include "ObjectModel.h"




IDocuments::IDocuments()
{
	CXOM_METHOD_REGISTER(Open,&IDocuments::Open);
}


IDocument* IDocuments::Item(char* id)
{
	_ASSERT( m_cpBase != NULL);
	_ASSERT( id != NULL);

	if ( !m_cpBase )
		return 0;

	int i = atol(id);
	MyDocuments* docs = (MyDocuments*) m_cpBase;
	if (!docs)
		return NULL;

	MyDocument* doc = docs->GetAt(i);
	IDocument* idoc = new IDocument();
	idoc->SetBase(doc);

	return NULL;
}

IDocument* IDocuments::operator[](char* id)
{
	return Item(id);
}

int	IDocuments::Count()
{
	_ASSERT( m_cpBase != NULL);

	if ( !m_cpBase )
		return 0;

	MyDocuments* docs = (MyDocuments*) m_cpBase;

	return docs->GetSize();
}


int IDocuments::Open(va_list* argList)
{
	_ASSERT( m_cpBase != NULL);
	_ASSERT( argList != NULL);

/* sample impl, we go through all parameters
	char* p = NULL;
	while ( (p=va_arg(*argList,char*)) != NULL)
	{}

	::MessageBox(NULL,"oh you just can't be...","info",MB_OK);
	return 0;*/

	// grab the first parameter being passed
	char* p = va_arg(*argList,char*);
	if (!m_cpBase || !p)
		return 0;

	typedef MyDocument** LPLPMyDocument;

	// grab the second parameter
	LPLPMyDocument ppdoc = va_arg(*argList,LPLPMyDocument);
	if (!ppdoc)
		return E_INVALIDARG;

	MyDocuments* docs = (MyDocuments*) m_cpBase;
	*ppdoc = docs->OpenDocument(p);

	return S_OK; // return error code (0 = OK)
}


/*
int IDocuments::MethodCall(char* methodname, ...)
{
	typedef (IDocuments::*tt_m)(va_list* argList);
	tt_m pfunc = m_htVptrs.Lookup(methodname,NULL);
	if (!pfunc)
		return 0;

	va_list argList;
	va_start(argList, methodname);

	return (this->*pfunc)(&argList);

	va_end(argList);

}
*/





ISection::ISection()
{
	CXOM_METHOD_REGISTER(Text,&ISection::Text);
}


int ISection::Text(va_list* argList)
{
	_ASSERT( m_cpBase != NULL);
	_ASSERT( argList != NULL);

	// TODO : implementation

	return S_OK; // return error code (0 = OK)
}
