


#pragma once

class IDocument; // forward declaration
class ISection; // forward declaration

class IDocuments : public IBase
{
public:
	IDocuments();

	CXOM_DEFAULT(IDocuments);
	CXOM_INDEXER(IDocument);
	CXOM_METHOD_GENERICDECL(IDocuments);
	CXOM_METHOD(Open);
};


class IDocument : public IBase
{
public:
	CXOM_DEFAULT(IDocument);
	CXOM_INDEXER(ISection);
	CXOM_METHOD_GENERICDECL(IDocument);
};



class ISection : public IBase
{
public:
	ISection();

	CXOM_DEFAULT(ISection);
	CXOM_INDEXER(ISection); // subsections
	CXOM_METHOD_GENERICDECL(ISection);
	CXOM_METHOD(Text);
};

